/*
 * lab1.c
 */

#include "usart.h"

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <string.h>


#define TASK_NR 0

#define MORSE_LUNG  3
#define MORSE_SCURT 1
#define SPEED_DEFAULT  50
#define SERVO_DEFAULT  402
#define DIRECTION_DEFAULT  1
#define REDUCE_SPEED  0.8


int speed = 50;  
int servo = 402;
int direction = 1;
int horn = 0;
int lights = 0;
int multiplu = 0;
uint8_t oc = 180;


/*void getData(){

	
	Bluetooth_parseSpeed(&speed);
	Bluetooth_parseServo(&servo);
	Bluetooth_parseDirection(&direction);
	Bluetooth_parseLights(&lights);
	Bluetooth_parseHorn(&horn);
PORTA|=(1<<PA0);
//	last2(&speed,&servo,&direction,&lights,&horn);

	if(speed<=0 || speed>255)
		speed = SPEED_DEFAULT;
		
	if(servo<355 || servo>450)
		servo = SERVO_DEFAULT;
		
	if(direction!=0 && direction!=1)
		direction = DIRECTION_DEFAULT;
	
}*/

void Speaker_init(void)
{
	DDRC |= (1 << PC6);
}

void servo_init(void){

 TCCR1A|=(1<<COM1A1)|(1<<COM1B1)|(1<<WGM11);        //NON Inverted PWM
   TCCR1B|=(1<<WGM13)|(1<<WGM12)|(1<<CS11)|(1<<CS10); //PRESCALER=64 MODE 14(FAST PWM)

   ICR1=4999;  //fPWM=50Hz (Period = 20ms Standard).

   DDRC|=(1<<PC3)|(1<<PC4);   //PWM Pins as Out

   
   OCR1A = 402;

}

void dc_motor_init(void){

	//Configure TIMER0
	TCCR0A |= (1 << WGM01) | (1 << WGM00);
	
	/* Non inverting mode */
	TCCR0A |= (1 << COM0A1) | (1 << COM0B1);
	
	/* No prescaling */
	TCCR0B |= (1 << CS00);
  
   DDRB|=(1<<PB3);   //PWM Pins as Out
  
   DDRA|=(1<<PA1)|(1<<PA2);
	
   	PORTA|=(1<<PA1);



}
int main()
{	USART0_init();
	//Bluetooth_init();
	//servo_init();
	dc_motor_init();
	//Speaker_init();
	char c;
	//DDRB|=(1<<PB0);
	//DDRA|=(1<<PA1);
	DDRA|=(1<<PA0);

	DDRA &= ~(1<<PA3);
	PORTA |= (1 << PA3);
	DDRD |= (1 << PD7);


	/*activate tx*/
	//PORTD |= (1 << PD3);

	//lights = 1;
	while(true){
		
	
	c = USART0_receive();
	switch(c) {

				case 'f': // Inainte
					PORTD |= (1<<PD7);
					OCR0A = speed;
					PORTA = 0x00;
					PORTA|=(1<<PA1);	
					PORTA &= ~(1 << PA2);

					break;
				case 'b': // Inainte
					PORTA = 0x00;
					OCR0A = speed;
					PORTA |= (1 << PA2);	
					PORTA &= ~(1 << PA1);
					break;
				case 't': // Inainte
					//PORTA = 0x00
					//OCR0A = speed;
					PORTA &= ~(1 << PA2);	
					PORTA &= ~(1 << PA1);
					break;
				case 's':
					PORTC |= (1 << PC4);
					PORTC &= ~(1 << PC3);
					break;
				case 'd':
					PORTC |= (1 << PC3);
					PORTC &= ~(1 << PC4);
					break;
				case 'm':
					PORTC &= ~(1 << PC3);
					PORTC &= ~(1 << PC4);
					break;
				case 'h':
					while(c == 'h'){
						DDRC|=(1<<PC6);
						PINC=(1<<PC6);
						_delay_ms(5);
						multiplu ++ ;
					};
					DDRC &= ~(1<<PC6);
					break;
				case 'n':
					PORTB &= ~(1 << PB1);
					break;
				case 'l':
					PORTA |= (1 << PA0);
					break;
				case 'z':
					PORTA &= ~(1 << PA0);
					break;
				case '0':
					speed = 0;
					break;
				case '1':
					speed = 25;
					break;
				case '2':
					speed = 51;
					break;
				case '3':
					speed = 76;
					break;
				case '4':
					speed = 102;
					break;
				case '5':
					speed = 127;
					break;
				case '6':
					speed = 153;
					break;
				case '7':
					speed = 178;
					break;
				case '8':
					speed = 204;
					break;
				default: // NOP
					PORTC &= ~(1 << PC3);
					PORTC &= ~(1 << PC4);
					break;
			}//_delay_ms(5);
	
	
	}
	
   }
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	